c900272138307d6260875acf05c87ea6446e692c
[yardstick.git] / tools / yardstick-img-modify
1 #!/bin/bash
2
3 ##############################################################################
4 # Copyright (c) 2015 Ericsson AB and others.
5 #
6 # All rights reserved. This program and the accompanying materials
7 # are made available under the terms of the Apache License, Version 2.0
8 # which accompanies this distribution, and is available at
9 # http://www.apache.org/licenses/LICENSE-2.0
10 ##############################################################################
11
12 # yardstick-img-modify - download and modify a Ubuntu cloud image
13 #
14 # The actual customization is done by a script passed with an absolute path as
15 # the only single argument. The command needs to be invoked as sudo
16 #
17 # Example invocation:
18 # yardstick-img-modify /home/yardstick/tools/ubuntu-server-cloudimg-modify.sh
19 #
20 # Warning: the script will create files by default in:
21 #   /tmp/workspace/yardstick
22 # the files will be owned by root!
23 #
24 # TODO: image resize is needed if the base image is too small
25 #
26
27 set -e
28
29 die() {
30     echo "error: $1" >&2
31     exit 1
32 }
33
34 test $# -eq 1 || die "no image specific script as argument"
35 test $(id -u) -eq 0 || die "should invoke using sudo"
36
37 cmd=$1
38 test -x $cmd
39 mountdir="/mnt/yardstick"
40
41 workspace=${WORKSPACE:-"/tmp/workspace/yardstick"}
42 host=${HOST:-"cloud-images.ubuntu.com"}
43 release=${RELEASE:-"trusty"}
44 image_path="${release}/current/${release}-server-cloudimg-amd64-disk1.img"
45 image_url=${IMAGE_URL:-"https://${host}/${image_path}"}
46 md5sums_path="${release}/current/MD5SUMS"
47 md5sums_url=${MD5SUMS_URL:-"https://${host}/${md5sums_path}"}
48
49 imgfile="${workspace}/yardstick-${release}-server.img"
50 filename=$(basename $image_url)
51
52 # download and checksum base image, conditionally if local copy is outdated
53 download() {
54     test -d $workspace || mkdir -p $workspace
55     cd $workspace
56     rm -f MD5SUMS # always download the checksum file to a detect stale image
57     wget $md5sums_url
58     test -e $filename || wget -nc $image_url
59     grep $filename MD5SUMS | md5sum -c ||
60     if [ $? -ne 0 ]; then
61         rm $filename
62         wget -nc $image_url
63         grep $filename MD5SUMS | md5sum -c
64     fi
65     cp $filename $imgfile
66     cd -
67 }
68
69 # mount image
70 setup() {
71     mkdir -p $mountdir
72     if [ -f /etc/centos-release ]; then
73         # CentOS, mount image using guestmount.
74         # (needs libguestfs-tools installed)
75         export LIBGUESTFS_BACKEND=direct
76         guestmount -a $imgfile -i --rw $mountdir
77     else
78         # mount image using qemu-nbd
79         modprobe nbd max_part=16
80         qemu-nbd -c /dev/nbd0 $imgfile
81         partprobe /dev/nbd0
82
83         mount /dev/nbd0p1 $mountdir
84     fi
85     cp $cmd $mountdir/$(basename $cmd)
86 }
87
88 # modify image running a script using in a chrooted environment
89 modify() {
90     # resolv.conf does not exist in base image, pass nameserver value from host
91     nameserver_ip=$(grep -m 1 '^nameserver' \
92         /etc/resolv.conf | awk '{ print $2 '})
93     chroot $mountdir /$(basename $cmd) $nameserver_ip
94 }
95
96 # cleanup (umount) the image
97 cleanup() {
98     # designed to be idempotent
99     mount | grep $mountdir && umount $mountdir
100     test -b /dev/nbd0 && partprobe /dev/nbd0
101     pgrep qemu-nbd && qemu-nbd -d /dev/nbd0
102     rm -rf $mountdir
103     killall qemu-nbd 2> /dev/null || true
104     lsmod | grep nbd && rmmod nbd || true
105 }
106
107 main() {
108     cleanup
109     download
110     setup
111     modify
112     cleanup
113
114     echo "the modified image is found here: $imgfile"
115 }
116
117 main
118